---@meta

---@class AGameplayCameraActor : AGameplayCameraActorBase
---@field CameraComponent UGameplayCameraComponent
local AGameplayCameraActor = {}

---@return UGameplayCameraComponent
function AGameplayCameraActor:GetCameraComponent() end


---@class AGameplayCameraActorBase : AActor
local AGameplayCameraActorBase = {}


---@class AGameplayCameraRigActor : AGameplayCameraActorBase
---@field CameraRigComponent UGameplayCameraRigComponent
local AGameplayCameraRigActor = {}

---@return UGameplayCameraRigComponent
function AGameplayCameraRigActor:GetCameraRigComponent() end


---@class AGameplayCameraSystemActor : AActor
---@field CameraSystemComponent UGameplayCameraSystemComponent
local AGameplayCameraSystemActor = {}

---@return UGameplayCameraSystemComponent
function AGameplayCameraSystemActor:GetCameraSystemComponent() end


---@class AGameplayCamerasPlayerCameraManager : APlayerCameraManager
---@field ViewRotationMode EGameplayCamerasViewRotationMode
---@field bOverrideViewRotationMode boolean
---@field OriginalCameraManager APlayerCameraManager
local AGameplayCamerasPlayerCameraManager = {}

---@param InstanceId FCameraRigInstanceID
---@param bImmediately boolean
function AGameplayCamerasPlayerCameraManager:StopCameraModifierRig(InstanceId, bImmediately) end
---@param PlayerController APlayerController
function AGameplayCamerasPlayerCameraManager:StealPlayerController(PlayerController) end
---@param CameraRig UCameraRigAsset
---@param OrderKey int32
---@return FCameraRigInstanceID
function AGameplayCamerasPlayerCameraManager:StartVisualCameraModifierRig(CameraRig, OrderKey) end
---@param CameraRig UCameraRigAsset
---@param OrderKey int32
---@return FCameraRigInstanceID
function AGameplayCamerasPlayerCameraManager:StartGlobalCameraModifierRig(CameraRig, OrderKey) end
function AGameplayCamerasPlayerCameraManager:ReleasePlayerController() end


---@class FBaseCameraObjectReference
---@field Parameters FInstancedPropertyBag
---@field ParameterMetaData TArray<FCameraObjectInterfaceParameterMetaData>
local FBaseCameraObjectReference = {}



---@class FBlueprintCameraDirectorActivateParams
---@field EvaluationContextOwner UObject
local FBlueprintCameraDirectorActivateParams = {}



---@class FBlueprintCameraDirectorDeactivateParams
---@field EvaluationContextOwner UObject
local FBlueprintCameraDirectorDeactivateParams = {}



---@class FBlueprintCameraDirectorEvaluationParams
---@field DeltaTime float
---@field EvaluationContextOwner UObject
local FBlueprintCameraDirectorEvaluationParams = {}



---@class FBlueprintCameraEvaluationDataRef
local FBlueprintCameraEvaluationDataRef = {}


---@class FBlueprintCameraPose
---@field Location FVector
---@field Rotation FRotator
---@field TargetDistance double
---@field FieldOfView float
---@field FocalLength float
---@field OrthographicWidth float
---@field Aperture float
---@field ShutterSpeed float
---@field FocusDistance float
---@field SensorWidth float
---@field SensorHeight float
---@field SensorHorizontalOffset float
---@field SensorVerticalOffset float
---@field ISO float
---@field SqueezeFactor float
---@field Overscan float
---@field DiaphragmBladeCount int32
---@field NearClippingPlane float
---@field FarClippingPlane float
---@field PhysicalCameraBlendWeight float
---@field EnablePhysicalCamera boolean
---@field ConstrainAspectRatio boolean
---@field OverrideAspectRatioAxisConstraint boolean
---@field AspectRatioAxisConstraint EAspectRatioAxisConstraint
---@field ProjectionMode ECameraProjectionMode::Type
local FBlueprintCameraPose = {}



---@class FBooleanCameraParameter
---@field Value boolean
---@field VariableID FCameraVariableID
---@field Variable UBooleanCameraVariable
local FBooleanCameraParameter = {}



---@class FBooleanCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FBooleanCameraParameter
local FBooleanCameraRigParameterOverride = {}



---@class FBooleanCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UBooleanCameraVariable
local FBooleanCameraVariableReference = {}



---@class FCameraActorAttachmentInfo
---@field Actor AActor
---@field SocketName FName
---@field BoneName FName
---@field Weight float
local FCameraActorAttachmentInfo = {}



---@class FCameraActorTargetInfo
---@field Actor AActor
---@field SocketName FName
---@field BoneName FName
---@field TargetShape ECameraTargetShape
---@field TargetSize float
---@field Weight float
local FCameraActorTargetInfo = {}



---@class FCameraAssetAllocationInfo
---@field VariableTableInfo FCameraVariableTableAllocationInfo
---@field ContextDataTableInfo FCameraContextDataTableAllocationInfo
local FCameraAssetAllocationInfo = {}



---@class FCameraAssetReference
---@field CameraAsset UCameraAsset
---@field Parameters FInstancedPropertyBag
---@field ParameterOverrideGuids TArray<FGuid>
---@field ParameterAnimatedGuids TArray<FGuid>
local FCameraAssetReference = {}



---@class FCameraContextDataDefinition
---@field DataID FCameraContextDataID
---@field DataType ECameraContextDataType
---@field DataContainerType ECameraContextDataContainerType
---@field DataTypeObject UObject
---@field bAutoReset boolean
local FCameraContextDataDefinition = {}



---@class FCameraContextDataID
---@field Value uint32
local FCameraContextDataID = {}



---@class FCameraContextDataTableAllocationInfo
---@field DataDefinitions TArray<FCameraContextDataDefinition>
local FCameraContextDataTableAllocationInfo = {}



---@class FCameraDirectorStateTreeEvaluationData
---@field ActiveCameraRigs TArray<UCameraRigAsset>
---@field ActiveCameraRigProxies TArray<UCameraRigProxyAsset>
local FCameraDirectorStateTreeEvaluationData = {}



---@class FCameraFramingZone
---@field Left double
---@field Top double
---@field Right double
---@field Bottom double
local FCameraFramingZone = {}



---@class FCameraFramingZoneParameter
---@field Value FCameraFramingZone
---@field VariableID FCameraVariableID
local FCameraFramingZoneParameter = {}



---@class FCameraNodeEvaluatorAllocationInfo
---@field TotalSizeof int16
---@field MaxAlignof int16
local FCameraNodeEvaluatorAllocationInfo = {}



---@class FCameraObjectAllocationInfo
---@field EvaluatorInfo FCameraNodeEvaluatorAllocationInfo
---@field VariableTableInfo FCameraVariableTableAllocationInfo
---@field ContextDataTableInfo FCameraContextDataTableAllocationInfo
local FCameraObjectAllocationInfo = {}



---@class FCameraObjectInterface
---@field BlendableParameters TArray<UCameraObjectInterfaceBlendableParameter>
---@field DataParameters TArray<UCameraObjectInterfaceDataParameter>
---@field DisplayName FString
local FCameraObjectInterface = {}



---@class FCameraObjectInterfaceParameterDefinition
---@field ParameterName FName
---@field ParameterGuid FGuid
---@field ParameterType ECameraObjectInterfaceParameterType
---@field VariableID FCameraVariableID
---@field VariableType ECameraVariableType
---@field BlendableStructType UScriptStruct
---@field DataID FCameraContextDataID
---@field DataType ECameraContextDataType
---@field DataContainerType ECameraContextDataContainerType
---@field DataTypeObject UObject
local FCameraObjectInterfaceParameterDefinition = {}



---@class FCameraObjectInterfaceParameterMetaData
---@field ParameterGuid FGuid
---@field OverrideVariableID FCameraVariableID
---@field OverrideDataID FCameraContextDataID
---@field bIsOverridden boolean
---@field bIsAnimated boolean
local FCameraObjectInterfaceParameterMetaData = {}



---@class FCameraParameterClamping
---@field MinValue double
---@field MaxValue double
---@field bClampMin boolean
---@field bClampMax boolean
local FCameraParameterClamping = {}



---@class FCameraParameterNormalization
---@field MaxValue double
---@field bNormalize boolean
local FCameraParameterNormalization = {}



---@class FCameraPose
---@field Location FVector3d
---@field Rotation FRotator3d
---@field TargetDistance double
---@field FieldOfView float
---@field FocalLength float
---@field OrthographicWidth float
---@field Aperture float
---@field ShutterSpeed float
---@field FocusDistance float
---@field SensorWidth float
---@field SensorHeight float
---@field SensorHorizontalOffset float
---@field SensorVerticalOffset float
---@field ISO float
---@field SqueezeFactor float
---@field Overscan float
---@field DiaphragmBladeCount int32
---@field NearClippingPlane float
---@field FarClippingPlane float
---@field PhysicalCameraBlendWeight float
---@field EnablePhysicalCamera boolean
---@field ConstrainAspectRatio boolean
---@field OverrideAspectRatioAxisConstraint boolean
---@field AspectRatioAxisConstraint EAspectRatioAxisConstraint
---@field ProjectionMode ECameraProjectionMode::Type
local FCameraPose = {}



---@class FCameraRigAssetReference : FBaseCameraObjectReference
---@field CameraRig UCameraRigAsset
---@field ParameterOverrideGuids TArray<FGuid>
---@field ParameterOverrides FCameraRigParameterOverrides
local FCameraRigAssetReference = {}



---@class FCameraRigInputSlotParameters
---@field bIsAccumulated boolean
---@field bIsPreBlended boolean
local FCameraRigInputSlotParameters = {}



---@class FCameraRigInstanceID
---@field Value uint32
---@field Layer ECameraRigLayer
local FCameraRigInstanceID = {}



---@class FCameraRigParameterOverrideBase
---@field InterfaceParameterGuid FGuid
---@field PrivateVariableGuid FGuid
---@field InterfaceParameterName FString
---@field bInvalid boolean
local FCameraRigParameterOverrideBase = {}



---@class FCameraRigParameterOverrides
---@field BooleanOverrides TArray<FBooleanCameraRigParameterOverride>
---@field Integer32Overrides TArray<FInteger32CameraRigParameterOverride>
---@field FloatOverrides TArray<FFloatCameraRigParameterOverride>
---@field DoubleOverrides TArray<FDoubleCameraRigParameterOverride>
---@field Vector2fOverrides TArray<FVector2fCameraRigParameterOverride>
---@field Vector2dOverrides TArray<FVector2dCameraRigParameterOverride>
---@field Vector3fOverrides TArray<FVector3fCameraRigParameterOverride>
---@field Vector3dOverrides TArray<FVector3dCameraRigParameterOverride>
---@field Vector4fOverrides TArray<FVector4fCameraRigParameterOverride>
---@field Vector4dOverrides TArray<FVector4dCameraRigParameterOverride>
---@field Rotator3fOverrides TArray<FRotator3fCameraRigParameterOverride>
---@field Rotator3dOverrides TArray<FRotator3dCameraRigParameterOverride>
---@field Transform3fOverrides TArray<FTransform3fCameraRigParameterOverride>
---@field Transform3dOverrides TArray<FTransform3dCameraRigParameterOverride>
local FCameraRigParameterOverrides = {}



---@class FCameraRigProxyRedirectTable
---@field Entries TArray<FCameraRigProxyRedirectTableEntry>
local FCameraRigProxyRedirectTable = {}



---@class FCameraRigProxyRedirectTableEntry
---@field CameraRigProxy UCameraRigProxyAsset
---@field CameraRig UCameraRigAsset
local FCameraRigProxyRedirectTableEntry = {}



---@class FCameraRotatorCurve
---@field Curves FRichCurve
local FCameraRotatorCurve = {}



---@class FCameraShakeAssetReference : FBaseCameraObjectReference
---@field CameraShake UCameraShakeAsset
local FCameraShakeAssetReference = {}



---@class FCameraSingleCurve
---@field Curve FRichCurve
local FCameraSingleCurve = {}



---@class FCameraVariableDefinition
---@field VariableID FCameraVariableID
---@field VariableType ECameraVariableType
---@field BlendableStructType UScriptStruct
---@field bIsPrivate boolean
---@field bIsInput boolean
---@field bAutoReset boolean
local FCameraVariableDefinition = {}



---@class FCameraVariableID
---@field Value uint32
local FCameraVariableID = {}



---@class FCameraVariableSetterHandle
---@field Value uint32
---@field SerialNumber uint32
local FCameraVariableSetterHandle = {}



---@class FCameraVariableTableAllocationInfo
---@field VariableDefinitions TArray<FCameraVariableDefinition>
local FCameraVariableTableAllocationInfo = {}



---@class FCameraVectorCurve
---@field Curves FRichCurve
local FCameraVectorCurve = {}



---@class FCustomCameraNodeBlendableParameter
---@field ParameterName FName
---@field ParameterType ECameraVariableType
---@field BlendableStructType UScriptStruct
---@field OverrideVariableID FCameraVariableID
---@field OverrideVariable UCameraVariableAsset
local FCustomCameraNodeBlendableParameter = {}



---@class FCustomCameraNodeDataParameter
---@field ParameterName FName
---@field ParameterType ECameraContextDataType
---@field ParameterContainerType ECameraContextDataContainerType
---@field ParameterTypeObject UObject
---@field OverrideDataID FCameraContextDataID
local FCustomCameraNodeDataParameter = {}



---@class FCustomCameraNodeParameters
---@field BlendableParameters TArray<FCustomCameraNodeBlendableParameter>
---@field DataParameters TArray<FCustomCameraNodeDataParameter>
local FCustomCameraNodeParameters = {}



---@class FDoubleCameraParameter
---@field Value double
---@field VariableID FCameraVariableID
---@field Variable UDoubleCameraVariable
local FDoubleCameraParameter = {}



---@class FDoubleCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FDoubleCameraParameter
local FDoubleCameraRigParameterOverride = {}



---@class FDoubleCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UDoubleCameraVariable
local FDoubleCameraVariableReference = {}



---@class FFloatCameraParameter
---@field Value float
---@field VariableID FCameraVariableID
---@field Variable UFloatCameraVariable
local FFloatCameraParameter = {}



---@class FFloatCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FFloatCameraParameter
local FFloatCameraRigParameterOverride = {}



---@class FFloatCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UFloatCameraVariable
local FFloatCameraVariableReference = {}



---@class FGameplayCamerasActivateCameraRigTask : FGameplayCamerasStateTreeTask
---@field bRunOnce boolean
local FGameplayCamerasActivateCameraRigTask = {}



---@class FGameplayCamerasActivateCameraRigTaskInstanceData
---@field CameraRig UCameraRigAsset
local FGameplayCamerasActivateCameraRigTaskInstanceData = {}



---@class FGameplayCamerasActivateCameraRigViaProxyTask : FGameplayCamerasStateTreeTask
---@field bRunOnce boolean
local FGameplayCamerasActivateCameraRigViaProxyTask = {}



---@class FGameplayCamerasActivateCameraRigViaProxyTaskInstanceData
---@field CameraRigProxy UCameraRigProxyAsset
local FGameplayCamerasActivateCameraRigViaProxyTaskInstanceData = {}



---@class FGameplayCamerasStateTreeCondition : FStateTreeConditionBase
local FGameplayCamerasStateTreeCondition = {}


---@class FGameplayCamerasStateTreeTask : FStateTreeTaskBase
local FGameplayCamerasStateTreeTask = {}


---@class FInteger32CameraParameter
---@field Value int32
---@field VariableID FCameraVariableID
---@field Variable UInteger32CameraVariable
local FInteger32CameraParameter = {}



---@class FInteger32CameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FInteger32CameraParameter
local FInteger32CameraRigParameterOverride = {}



---@class FInteger32CameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UInteger32CameraVariable
local FInteger32CameraVariableReference = {}



---@class FPerlinNoiseData
---@field Amplitude float
---@field Frequency float
local FPerlinNoiseData = {}



---@class FRotator3dCameraParameter
---@field Value FRotator
---@field VariableID FCameraVariableID
---@field Variable URotator3dCameraVariable
local FRotator3dCameraParameter = {}



---@class FRotator3dCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FRotator3dCameraParameter
local FRotator3dCameraRigParameterOverride = {}



---@class FRotator3dCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable URotator3dCameraVariable
local FRotator3dCameraVariableReference = {}



---@class FRotator3fCameraParameter
---@field Value FRotator3f
---@field VariableID FCameraVariableID
---@field Variable URotator3fCameraVariable
local FRotator3fCameraParameter = {}



---@class FRotator3fCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FRotator3fCameraParameter
local FRotator3fCameraRigParameterOverride = {}



---@class FRotator3fCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable URotator3fCameraVariable
local FRotator3fCameraVariableReference = {}



---@class FSplineOrbitControlPoint
---@field LocationOffset FVector3d
---@field TargetOffset FVector3d
---@field RotationOffset FRotator3d
---@field PitchAngle float
local FSplineOrbitControlPoint = {}



---@class FTransform3dCameraParameter
---@field Value FTransform
---@field VariableID FCameraVariableID
---@field Variable UTransform3dCameraVariable
local FTransform3dCameraParameter = {}



---@class FTransform3dCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FTransform3dCameraParameter
local FTransform3dCameraRigParameterOverride = {}



---@class FTransform3dCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UTransform3dCameraVariable
local FTransform3dCameraVariableReference = {}



---@class FTransform3fCameraParameter
---@field Value FTransform3f
---@field VariableID FCameraVariableID
---@field Variable UTransform3fCameraVariable
local FTransform3fCameraParameter = {}



---@class FTransform3fCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FTransform3fCameraParameter
local FTransform3fCameraRigParameterOverride = {}



---@class FTransform3fCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UTransform3fCameraVariable
local FTransform3fCameraVariableReference = {}



---@class FVector2dCameraParameter
---@field Value FVector2D
---@field VariableID FCameraVariableID
---@field Variable UVector2dCameraVariable
local FVector2dCameraParameter = {}



---@class FVector2dCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FVector2dCameraParameter
local FVector2dCameraRigParameterOverride = {}



---@class FVector2dCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UVector2dCameraVariable
local FVector2dCameraVariableReference = {}



---@class FVector2fCameraParameter
---@field Value FVector2f
---@field VariableID FCameraVariableID
---@field Variable UVector2fCameraVariable
local FVector2fCameraParameter = {}



---@class FVector2fCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FVector2fCameraParameter
local FVector2fCameraRigParameterOverride = {}



---@class FVector2fCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UVector2fCameraVariable
local FVector2fCameraVariableReference = {}



---@class FVector3dCameraParameter
---@field Value FVector
---@field VariableID FCameraVariableID
---@field Variable UVector3dCameraVariable
local FVector3dCameraParameter = {}



---@class FVector3dCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FVector3dCameraParameter
local FVector3dCameraRigParameterOverride = {}



---@class FVector3dCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UVector3dCameraVariable
local FVector3dCameraVariableReference = {}



---@class FVector3fCameraParameter
---@field Value FVector3f
---@field VariableID FCameraVariableID
---@field Variable UVector3fCameraVariable
local FVector3fCameraParameter = {}



---@class FVector3fCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FVector3fCameraParameter
local FVector3fCameraRigParameterOverride = {}



---@class FVector3fCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UVector3fCameraVariable
local FVector3fCameraVariableReference = {}



---@class FVector4dCameraParameter
---@field Value FVector4
---@field VariableID FCameraVariableID
---@field Variable UVector4dCameraVariable
local FVector4dCameraParameter = {}



---@class FVector4dCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FVector4dCameraParameter
local FVector4dCameraRigParameterOverride = {}



---@class FVector4dCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UVector4dCameraVariable
local FVector4dCameraVariableReference = {}



---@class FVector4fCameraParameter
---@field Value FVector4f
---@field VariableID FCameraVariableID
---@field Variable UVector4fCameraVariable
local FVector4fCameraParameter = {}



---@class FVector4fCameraRigParameterOverride : FCameraRigParameterOverrideBase
---@field Value FVector4fCameraParameter
local FVector4fCameraRigParameterOverride = {}



---@class FVector4fCameraVariableReference
---@field VariableID FCameraVariableID
---@field Variable UVector4fCameraVariable
local FVector4fCameraVariableReference = {}



---@class IAssetReferenceCameraNode : IInterface
local IAssetReferenceCameraNode = {}


---@class ICustomCameraNodeParameterProvider : IInterface
local ICustomCameraNodeParameterProvider = {}


---@class IGameplayCameraSystemHost : IInterface
local IGameplayCameraSystemHost = {}


---@class IHasCameraBuildStatus : IInterface
local IHasCameraBuildStatus = {}


---@class IObjectTreeGraphObject : IInterface
local IObjectTreeGraphObject = {}


---@class IObjectTreeGraphRootObject : IInterface
local IObjectTreeGraphRootObject = {}


---@class UAccelerationDecelerationValueInterpolator : UCameraValueInterpolator
---@field Acceleration float
---@field MaxSpeed float
---@field Deceleration float
local UAccelerationDecelerationValueInterpolator = {}



---@class UActivateCameraRigFunctions : UBlueprintFunctionLibrary
local UActivateCameraRigFunctions = {}

---@param WorldContextObject UObject
---@param PlayerController APlayerController
---@param CameraRig UCameraRigAsset
function UActivateCameraRigFunctions:ActivatePersistentVisualCameraRig(WorldContextObject, PlayerController, CameraRig) end
---@param WorldContextObject UObject
---@param PlayerController APlayerController
---@param CameraRig UCameraRigAsset
function UActivateCameraRigFunctions:ActivatePersistentGlobalCameraRig(WorldContextObject, PlayerController, CameraRig) end
---@param WorldContextObject UObject
---@param PlayerController APlayerController
---@param CameraRig UCameraRigAsset
function UActivateCameraRigFunctions:ActivatePersistentBaseCameraRig(WorldContextObject, PlayerController, CameraRig) end


---@class UArrayCameraNode : UCameraNode
---@field Children TArray<UCameraNode>
local UArrayCameraNode = {}



---@class UAttachToActorCameraNode : UCameraNode
---@field Attachment FCameraActorAttachmentInfo
---@field AttachmentDataID FCameraContextDataID
---@field AttachToLocation FBooleanCameraParameter
---@field AttachToRotation FBooleanCameraParameter
local UAttachToActorCameraNode = {}



---@class UAttachToActorGroupCameraNode : UCameraNode
---@field Attachments TArray<FCameraActorAttachmentInfo>
---@field AttachmentsDataID FCameraContextDataID
local UAttachToActorGroupCameraNode = {}



---@class UAttachToPlayerPawnCameraNode : UCameraNode
---@field AttachToLocation FBooleanCameraParameter
---@field AttachToRotation FBooleanCameraParameter
local UAttachToPlayerPawnCameraNode = {}



---@class UAutoFocusCameraNode : UCameraNode
---@field EnableAutoFocus FBooleanCameraVariableReference
---@field AutoFocusDampingFactor FFloatCameraParameter
local UAutoFocusCameraNode = {}



---@class UAutoRotateInput2DCameraNode : UInput2DCameraNode
---@field Direction ECameraAutoRotateDirection
---@field DirectionVector FVector3dCameraVariableReference
---@field WaitTime FFloatCameraParameter
---@field DeactivationThreshold FFloatCameraParameter
---@field Interpolator UCameraValueInterpolator
---@field FreezeControlRotation FBooleanCameraParameter
---@field EnableAutoRotate FBooleanCameraParameter
---@field AutoRotateYaw FBooleanCameraParameter
---@field AutoRotatePitch FBooleanCameraParameter
---@field InputNode UInput2DCameraNode
local UAutoRotateInput2DCameraNode = {}



---@class UBaseCameraObject : UObject
---@field Interface FCameraObjectInterface
---@field AllocationInfo FCameraObjectAllocationInfo
---@field DefaultParameters FInstancedPropertyBag
---@field ParameterDefinitions TArray<FCameraObjectInterfaceParameterDefinition>
local UBaseCameraObject = {}



---@class UBaseFramingCameraNode : UCameraNode
---@field TargetLocation FVector3dCameraVariableReference
---@field TargetInfos TArray<FCameraActorTargetInfo>
---@field TargetInfosDataID FCameraContextDataID
---@field SetTargetDistance FBooleanCameraParameter
---@field InitializeWithIdealFraming FBooleanCameraParameter
---@field IdealFramingLocation FVector2dCameraParameter
---@field ReframeDampingFactor FFloatCameraParameter
---@field LowReframeDampingFactor FFloatCameraParameter
---@field ReengageTime FFloatCameraParameter
---@field DisengageTime FFloatCameraParameter
---@field TargetMovementAnticipationTime FFloatCameraParameter
---@field DeadZone FCameraFramingZoneParameter
---@field SoftZone FCameraFramingZoneParameter
---@field TargetInfo FCameraActorTargetInfo
local UBaseFramingCameraNode = {}



---@class UBlendCameraNode : UCameraNode
local UBlendCameraNode = {}


---@class UBlendStackCameraNode : UCameraNode
---@field BlendStackType ECameraBlendStackType
---@field Layer ECameraRigLayer
local UBlendStackCameraNode = {}



---@class UBlendStackRootCameraNode : UCameraNode
---@field Blend UBlendCameraNode
---@field RootNode UCameraNode
local UBlendStackRootCameraNode = {}



---@class UBlueprintCameraContextDataTableFunctionLibrary : UBlueprintFunctionLibrary
local UBlueprintCameraContextDataTableFunctionLibrary = {}

---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@param Data FInstancedStruct
---@return boolean
function UBlueprintCameraContextDataTableFunctionLibrary:SetStructData(CameraData, DataID, Data) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@param Data FString
---@return boolean
function UBlueprintCameraContextDataTableFunctionLibrary:SetStringData(CameraData, DataID, Data) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@param Data UObject
---@return boolean
function UBlueprintCameraContextDataTableFunctionLibrary:SetObjectData(CameraData, DataID, Data) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@param Data FName
---@return boolean
function UBlueprintCameraContextDataTableFunctionLibrary:SetNameData(CameraData, DataID, Data) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@param EnumType UEnum
---@param Data uint8
---@return boolean
function UBlueprintCameraContextDataTableFunctionLibrary:SetEnumData(CameraData, DataID, EnumType, Data) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@param Data UClass
---@return boolean
function UBlueprintCameraContextDataTableFunctionLibrary:SetClassData(CameraData, DataID, Data) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@param DataStructType UScriptStruct
---@return FInstancedStruct
function UBlueprintCameraContextDataTableFunctionLibrary:GetStructData(CameraData, DataID, DataStructType) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@return FString
function UBlueprintCameraContextDataTableFunctionLibrary:GetStringData(CameraData, DataID) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@return UObject
function UBlueprintCameraContextDataTableFunctionLibrary:GetObjectData(CameraData, DataID) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@return FName
function UBlueprintCameraContextDataTableFunctionLibrary:GetNameData(CameraData, DataID) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@param EnumType UEnum
---@return uint8
function UBlueprintCameraContextDataTableFunctionLibrary:GetEnumData(CameraData, DataID, EnumType) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param DataID FCameraContextDataID
---@return UClass
function UBlueprintCameraContextDataTableFunctionLibrary:GetClassData(CameraData, DataID) end


---@class UBlueprintCameraDirector : UCameraDirector
---@field CameraDirectorEvaluatorClass TSubclassOf<UBlueprintCameraDirectorEvaluator>
local UBlueprintCameraDirector = {}



---@class UBlueprintCameraDirectorEvaluator : UObject
local UBlueprintCameraDirectorEvaluator = {}

---@param DeltaTime float
---@param ChildSlotName FName
---@return boolean
function UBlueprintCameraDirectorEvaluator:RunChildCameraDirector(DeltaTime, ChildSlotName) end
---@param DeltaTime float
---@param EvaluationContextOwner UObject
---@param Params FBlueprintCameraDirectorEvaluationParams
function UBlueprintCameraDirectorEvaluator:RunCameraDirector(DeltaTime, EvaluationContextOwner, Params) end
---@param ChildEvaluationContextOwner UObject
---@param ChildSlotName FName
---@return boolean
function UBlueprintCameraDirectorEvaluator:RemoveChildEvaluationContext(ChildEvaluationContextOwner, ChildSlotName) end
---@return FBlueprintCameraEvaluationDataRef
function UBlueprintCameraDirectorEvaluator:GetInitialContextResult() end
---@param Condition ECameraEvaluationDataCondition
---@return FBlueprintCameraEvaluationDataRef
function UBlueprintCameraDirectorEvaluator:GetConditionalContextResult(Condition) end
---@param ActorClass TSubclassOf<AActor>
---@return AActor
function UBlueprintCameraDirectorEvaluator:FindEvaluationContextOwnerActor(ActorClass) end
---@param CameraRigPrefab UCameraRigAsset
function UBlueprintCameraDirectorEvaluator:DeactivatePersistentVisualCameraRig(CameraRigPrefab) end
---@param CameraRigPrefab UCameraRigAsset
function UBlueprintCameraDirectorEvaluator:DeactivatePersistentGlobalCameraRig(CameraRigPrefab) end
---@param CameraRigPrefab UCameraRigAsset
function UBlueprintCameraDirectorEvaluator:DeactivatePersistentBaseCameraRig(CameraRigPrefab) end
---@param EvaluationContextOwner UObject
---@param Params FBlueprintCameraDirectorDeactivateParams
function UBlueprintCameraDirectorEvaluator:DeactivateCameraDirector(EvaluationContextOwner, Params) end
---@param ChildEvaluationContextOwner UObject
---@return FName
function UBlueprintCameraDirectorEvaluator:AddChildEvaluationContext(ChildEvaluationContextOwner) end
---@param CameraRigPrefab UCameraRigAsset
function UBlueprintCameraDirectorEvaluator:ActivatePersistentVisualCameraRig(CameraRigPrefab) end
---@param CameraRigPrefab UCameraRigAsset
function UBlueprintCameraDirectorEvaluator:ActivatePersistentGlobalCameraRig(CameraRigPrefab) end
---@param CameraRigPrefab UCameraRigAsset
function UBlueprintCameraDirectorEvaluator:ActivatePersistentBaseCameraRig(CameraRigPrefab) end
---@param CameraRigProxy UCameraRigProxyAsset
---@param bForceNewInstance boolean
function UBlueprintCameraDirectorEvaluator:ActivateCameraRigViaProxy(CameraRigProxy, bForceNewInstance) end
---@param CameraRig UCameraRigAsset
---@param bForceNewInstance boolean
function UBlueprintCameraDirectorEvaluator:ActivateCameraRig(CameraRig, bForceNewInstance) end
---@param EvaluationContextOwner UObject
---@param Params FBlueprintCameraDirectorActivateParams
function UBlueprintCameraDirectorEvaluator:ActivateCameraDirector(EvaluationContextOwner, Params) end


---@class UBlueprintCameraEvaluationDataFunctionLibrary : UBlueprintFunctionLibrary
local UBlueprintCameraEvaluationDataFunctionLibrary = {}

---@param CameraData FBlueprintCameraEvaluationDataRef
---@param CameraRig UCameraRigAsset
function UBlueprintCameraEvaluationDataFunctionLibrary:SetDefaultCameraRigParameters(CameraData, CameraRig) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param CameraPose FBlueprintCameraPose
function UBlueprintCameraEvaluationDataFunctionLibrary:SetCameraPose(CameraData, CameraPose) end
---@return FBlueprintCameraEvaluationDataRef
function UBlueprintCameraEvaluationDataFunctionLibrary:MakeCameraEvaluationData() end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@return FBlueprintCameraPose
function UBlueprintCameraEvaluationDataFunctionLibrary:GetCameraPose(CameraData) end
---@param FromCameraData FBlueprintCameraEvaluationDataRef
---@param ToCameraData FBlueprintCameraEvaluationDataRef
---@param Factor float
function UBlueprintCameraEvaluationDataFunctionLibrary:BlendCameraEvaluationData(FromCameraData, ToCameraData, Factor) end


---@class UBlueprintCameraNode : UCameraNode
---@field CameraNodeEvaluatorTemplate UBlueprintCameraNodeEvaluator
---@field CameraNodeEvaluatorOverrides FCustomCameraNodeParameters
---@field CameraNodeEvaluatorClass TSubclassOf<UBlueprintCameraNodeEvaluator>
local UBlueprintCameraNode = {}



---@class UBlueprintCameraNodeEvaluator : UObject
---@field bIsFirstFrame boolean
---@field EvaluationContextOwner UObject
---@field CameraData FBlueprintCameraEvaluationDataRef
---@field CameraPose FBlueprintCameraPose
---@field VariableTable FBlueprintCameraEvaluationDataRef
local UBlueprintCameraNodeEvaluator = {}

---@param DeltaTime float
function UBlueprintCameraNodeEvaluator:TickCameraNode(DeltaTime) end
---@param TargetCameraData FBlueprintCameraEvaluationDataRef
function UBlueprintCameraNodeEvaluator:SetDefaultOwningCameraRigParameters(TargetCameraData) end
---@param CameraPose FBlueprintCameraPose
function UBlueprintCameraNodeEvaluator:SetCurrentCameraPose(CameraPose) end
---@param InCameraPose FBlueprintCameraPose
function UBlueprintCameraNodeEvaluator:SetCameraPose(InCameraPose) end
function UBlueprintCameraNodeEvaluator:InitializeCameraNode() end
---@return APlayerController
function UBlueprintCameraNodeEvaluator:GetPlayerController() end
---@return FBlueprintCameraPose
function UBlueprintCameraNodeEvaluator:GetCurrentCameraPose() end
---@return FBlueprintCameraPose
function UBlueprintCameraNodeEvaluator:GetCameraPose() end
---@param ActorClass TSubclassOf<AActor>
---@return AActor
function UBlueprintCameraNodeEvaluator:FindEvaluationContextOwnerActor(ActorClass) end


---@class UBlueprintCameraPoseFunctionLibrary : UBlueprintFunctionLibrary
local UBlueprintCameraPoseFunctionLibrary = {}

---@param CameraPose FBlueprintCameraPose
---@param Transform FTransform
---@return FBlueprintCameraPose
function UBlueprintCameraPoseFunctionLibrary:SetTransform(CameraPose, Transform) end
---@param CameraPose FBlueprintCameraPose
---@param TargetDistance double
---@return FBlueprintCameraPose
function UBlueprintCameraPoseFunctionLibrary:SetTargetDistance(CameraPose, TargetDistance) end
---@param CameraPose FBlueprintCameraPose
---@param Rotation FRotator
---@return FBlueprintCameraPose
function UBlueprintCameraPoseFunctionLibrary:SetRotation(CameraPose, Rotation) end
---@param CameraPose FBlueprintCameraPose
---@param Location FVector
---@return FBlueprintCameraPose
function UBlueprintCameraPoseFunctionLibrary:SetLocation(CameraPose, Location) end
---@param CameraPose FBlueprintCameraPose
---@param FocalLength float
---@return FBlueprintCameraPose
function UBlueprintCameraPoseFunctionLibrary:SetFocalLength(CameraPose, FocalLength) end
---@param CameraPose FBlueprintCameraPose
---@param FieldOfView float
---@return FBlueprintCameraPose
function UBlueprintCameraPoseFunctionLibrary:SetFieldOfView(CameraPose, FieldOfView) end
---@param CameraComponent UCineCameraComponent
---@return FBlueprintCameraPose
function UBlueprintCameraPoseFunctionLibrary:MakeCameraPoseFromCineCameraComponent(CameraComponent) end
---@param CameraComponent UCameraComponent
---@return FBlueprintCameraPose
function UBlueprintCameraPoseFunctionLibrary:MakeCameraPoseFromCameraComponent(CameraComponent) end
---@param CameraPose FBlueprintCameraPose
---@return FTransform
function UBlueprintCameraPoseFunctionLibrary:GetTransform(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@return double
function UBlueprintCameraPoseFunctionLibrary:GetTargetDistance(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@param TargetDistance double
---@return FVector
function UBlueprintCameraPoseFunctionLibrary:GetTargetAtDistance(CameraPose, TargetDistance) end
---@param CameraPose FBlueprintCameraPose
---@return FVector
function UBlueprintCameraPoseFunctionLibrary:GetTarget(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@return double
function UBlueprintCameraPoseFunctionLibrary:GetSensorAspectRatio(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@return FRotator
function UBlueprintCameraPoseFunctionLibrary:GetRotation(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@return FVector
function UBlueprintCameraPoseFunctionLibrary:GetLocation(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@return double
function UBlueprintCameraPoseFunctionLibrary:GetFocalLength(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@return double
function UBlueprintCameraPoseFunctionLibrary:GetFieldOfView(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@return double
function UBlueprintCameraPoseFunctionLibrary:GetEffectiveFieldOfView(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@return FRay
function UBlueprintCameraPoseFunctionLibrary:GetAimRay(CameraPose) end
---@param CameraPose FBlueprintCameraPose
---@return FVector
function UBlueprintCameraPoseFunctionLibrary:GetAimDir(CameraPose) end


---@class UBlueprintCameraVariableTableFunctionLibrary : UBlueprintFunctionLibrary
local UBlueprintCameraVariableTableFunctionLibrary = {}

---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UVector4dCameraVariable
---@param Value FVector4
function UBlueprintCameraVariableTableFunctionLibrary:SetVector4CameraVariable(CameraData, Variable, Value) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UVector3dCameraVariable
---@param Value FVector
function UBlueprintCameraVariableTableFunctionLibrary:SetVector3CameraVariable(CameraData, Variable, Value) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UVector2dCameraVariable
---@param Value FVector2D
function UBlueprintCameraVariableTableFunctionLibrary:SetVector2CameraVariable(CameraData, Variable, Value) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UTransform3dCameraVariable
---@param Value FTransform
function UBlueprintCameraVariableTableFunctionLibrary:SetTransformCameraVariable(CameraData, Variable, Value) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable URotator3dCameraVariable
---@param Value FRotator
function UBlueprintCameraVariableTableFunctionLibrary:SetRotatorCameraVariable(CameraData, Variable, Value) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UInteger32CameraVariable
---@param Value int32
function UBlueprintCameraVariableTableFunctionLibrary:SetInteger32CameraVariable(CameraData, Variable, Value) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UFloatCameraVariable
---@param Value float
function UBlueprintCameraVariableTableFunctionLibrary:SetFloatCameraVariable(CameraData, Variable, Value) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UDoubleCameraVariable
---@param Value double
function UBlueprintCameraVariableTableFunctionLibrary:SetDoubleCameraVariable(CameraData, Variable, Value) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UBooleanCameraVariable
---@param Value boolean
function UBlueprintCameraVariableTableFunctionLibrary:SetBooleanCameraVariable(CameraData, Variable, Value) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UVector4dCameraVariable
---@return FVector4
function UBlueprintCameraVariableTableFunctionLibrary:GetVector4CameraVariable(CameraData, Variable) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UVector3dCameraVariable
---@return FVector
function UBlueprintCameraVariableTableFunctionLibrary:GetVector3CameraVariable(CameraData, Variable) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UVector2dCameraVariable
---@return FVector2D
function UBlueprintCameraVariableTableFunctionLibrary:GetVector2CameraVariable(CameraData, Variable) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UTransform3dCameraVariable
---@return FTransform
function UBlueprintCameraVariableTableFunctionLibrary:GetTransformCameraVariable(CameraData, Variable) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable URotator3dCameraVariable
---@return FRotator
function UBlueprintCameraVariableTableFunctionLibrary:GetRotatorCameraVariable(CameraData, Variable) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UInteger32CameraVariable
---@return int32
function UBlueprintCameraVariableTableFunctionLibrary:GetInteger32CameraVariable(CameraData, Variable) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UFloatCameraVariable
---@return float
function UBlueprintCameraVariableTableFunctionLibrary:GetFloatCameraVariable(CameraData, Variable) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UDoubleCameraVariable
---@return double
function UBlueprintCameraVariableTableFunctionLibrary:GetDoubleCameraVariable(CameraData, Variable) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param Variable UBooleanCameraVariable
---@return boolean
function UBlueprintCameraVariableTableFunctionLibrary:GetBooleanCameraVariable(CameraData, Variable) end


---@class UBodyParametersCameraNode : UCameraNode
---@field ShutterSpeed FFloatCameraParameter
---@field ISO FFloatCameraParameter
local UBodyParametersCameraNode = {}



---@class UBooleanCameraVariable : UCameraVariableAsset
---@field bDefaultValue boolean
local UBooleanCameraVariable = {}



---@class UBoomArmCameraNode : UCameraNode
---@field BoomOffset FVector3dCameraParameter
---@field BoomLengthInterpolator UCameraValueInterpolator
---@field MaxForwardInterpolationFactor FDoubleCameraParameter
---@field MaxBackwardInterpolationFactor FDoubleCameraParameter
---@field InputSlot UInput2DCameraNode
local UBoomArmCameraNode = {}



---@class UCalcCameraActorCameraNode : UCameraNode
local UCalcCameraActorCameraNode = {}


---@class UCameraAsset : UObject
---@field CameraDirector UCameraDirector
---@field EnterTransitions TArray<UCameraRigTransition>
---@field ExitTransitions TArray<UCameraRigTransition>
---@field BuildStatus ECameraBuildStatus
---@field DefaultParameters FInstancedPropertyBag
---@field ParameterDefinitions TArray<FCameraObjectInterfaceParameterDefinition>
---@field ParameterOwners TArray<UCameraRigAsset>
---@field AllocationInfo FCameraAssetAllocationInfo
---@field CameraRigs TArray<UCameraRigAsset>
local UCameraAsset = {}



---@class UCameraComponentCameraNode : UCameraNode
local UCameraComponentCameraNode = {}


---@class UCameraDirector : UObject
---@field CameraRigProxyRedirectTable FCameraRigProxyRedirectTable
---@field CameraRigProxyTable UCameraRigProxyTable
local UCameraDirector = {}



---@class UCameraDirectorStateTreeSchema : UStateTreeSchema
---@field ContextDataDescs TArray<FStateTreeExternalDataDesc>
local UCameraDirectorStateTreeSchema = {}



---@class UCameraNode : UObject
---@field bIsEnabled boolean
local UCameraNode = {}



---@class UCameraObjectInterfaceBlendableParameter : UCameraObjectInterfaceParameterBase
---@field ParameterType ECameraVariableType
---@field BlendableStructType UScriptStruct
---@field bIsPreBlended boolean
---@field PrivateVariableID FCameraVariableID
---@field PrivateVariable UCameraVariableAsset
local UCameraObjectInterfaceBlendableParameter = {}



---@class UCameraObjectInterfaceDataParameter : UCameraObjectInterfaceParameterBase
---@field DataType ECameraContextDataType
---@field DataContainerType ECameraContextDataContainerType
---@field DataTypeObject UObject
---@field PrivateDataID FCameraContextDataID
local UCameraObjectInterfaceDataParameter = {}



---@class UCameraObjectInterfaceParameterBase : UObject
---@field InterfaceParameterName FString
---@field Target UCameraNode
---@field TargetPropertyName FName
---@field Guid FGuid
local UCameraObjectInterfaceParameterBase = {}



---@class UCameraRigAsset : UBaseCameraObject
---@field RootNode UCameraNode
---@field GameplayTags FGameplayTagContainer
---@field EnterTransitions TArray<UCameraRigTransition>
---@field ExitTransitions TArray<UCameraRigTransition>
---@field InitialOrientation ECameraRigInitialOrientation
---@field BuildStatus ECameraBuildStatus
---@field Guid FGuid
local UCameraRigAsset = {}



---@class UCameraRigCameraNode : UCameraNode
---@field CameraRigReference FCameraRigAssetReference
local UCameraRigCameraNode = {}



---@class UCameraRigInput1DSlot : UInput1DCameraNode
---@field InputSlotParameters FCameraRigInputSlotParameters
---@field Clamp FCameraParameterClamping
---@field Normalize FCameraParameterNormalization
---@field BuiltInVariable EBuiltInDoubleCameraVariable
---@field CustomVariable FDoubleCameraVariableReference
---@field TransientVariableID FCameraVariableID
---@field VariableID FCameraVariableID
local UCameraRigInput1DSlot = {}



---@class UCameraRigInput2DSlot : UInput2DCameraNode
---@field InputSlotParameters FCameraRigInputSlotParameters
---@field ClampX FCameraParameterClamping
---@field ClampY FCameraParameterClamping
---@field NormalizeX FCameraParameterNormalization
---@field NormalizeY FCameraParameterNormalization
---@field BuiltInVariable EBuiltInVector2dCameraVariable
---@field CustomVariable FVector2dCameraVariableReference
---@field TransientVariableID FCameraVariableID
---@field VariableID FCameraVariableID
local UCameraRigInput2DSlot = {}



---@class UCameraRigInstanceFunctions : UBlueprintFunctionLibrary
local UCameraRigInstanceFunctions = {}

---@param InstanceId FCameraRigInstanceID
---@return boolean
function UCameraRigInstanceFunctions:IsValid(InstanceId) end


---@class UCameraRigParameterInterop : UBlueprintFunctionLibrary
local UCameraRigParameterInterop = {}

---@param CameraData FBlueprintCameraEvaluationDataRef
---@param CameraRig UCameraRigAsset
---@param ParameterName FName
---@param NewValue int32
function UCameraRigParameterInterop:SetCameraParameter(CameraData, CameraRig, ParameterName, NewValue) end
---@param CameraData FBlueprintCameraEvaluationDataRef
---@param CameraRig UCameraRigAsset
---@param ParameterName FName
---@param ReturnValue int32
function UCameraRigParameterInterop:GetCameraParameter(CameraData, CameraRig, ParameterName, ReturnValue) end


---@class UCameraRigProxyAsset : UObject
---@field Guid FGuid
local UCameraRigProxyAsset = {}



---@class UCameraRigProxyTable : UObject
---@field Entries TArray<FCameraRigProxyRedirectTableEntry>
local UCameraRigProxyTable = {}



---@class UCameraRigTransition : UObject
---@field Conditions TArray<UCameraRigTransitionCondition>
---@field Blend UBlendCameraNode
---@field InitialOrientation ECameraRigInitialOrientation
---@field bOverrideInitialOrientation boolean
---@field bAllowCameraRigMerging boolean
local UCameraRigTransition = {}



---@class UCameraRigTransitionCondition : UObject
local UCameraRigTransitionCondition = {}


---@class UCameraShakeAsset : UBaseCameraObject
---@field RootNode UShakeCameraNode
---@field BlendIn USimpleFixedTimeBlendCameraNode
---@field BlendOut USimpleFixedTimeBlendCameraNode
---@field bIsSingleInstance boolean
---@field BuildStatus ECameraBuildStatus
---@field Guid FGuid
local UCameraShakeAsset = {}



---@class UCameraShakeCameraNode : UCameraNode
---@field CameraShakeReference FCameraShakeAssetReference
---@field EvaluationMode ECameraShakeEvaluationMode
local UCameraShakeCameraNode = {}



---@class UCameraShakeServiceCameraNode : UCameraNode
local UCameraShakeServiceCameraNode = {}


---@class UCameraValueInterpolator : UObject
local UCameraValueInterpolator = {}


---@class UCameraVariableAsset : UObject
---@field bAutoReset boolean
---@field bIsPrivate boolean
---@field bIsInput boolean
---@field Guid FGuid
local UCameraVariableAsset = {}



---@class UCameraVariableCollection : UObject
---@field Variables TArray<UCameraVariableAsset>
local UCameraVariableCollection = {}



---@class UClippingPlanesCameraNode : UCameraNode
---@field NearPlane FDoubleCameraParameter
---@field FarPlane FDoubleCameraParameter
local UClippingPlanesCameraNode = {}



---@class UCollisionPushCameraNode : UCameraNode
---@field SafePosition ECollisionSafePosition
---@field CustomSafePosition FVector3dCameraVariableReference
---@field SafePositionOffset FVector3dCameraParameter
---@field SafePositionOffsetSpace ECollisionSafePositionOffsetSpace
---@field EnableCollision FBooleanCameraVariableReference
---@field CollisionSphereRadius FFloatCameraParameter
---@field CollisionChannel ECollisionChannel
---@field PushInterpolator UCameraValueInterpolator
---@field PullInterpolator UCameraValueInterpolator
---@field bRunAsyncCollision boolean
local UCollisionPushCameraNode = {}



---@class UCombinedCameraRigsCameraNode : UCameraNode
---@field CameraRigReferences TArray<FCameraRigAssetReference>
local UCombinedCameraRigsCameraNode = {}



---@class UCompositeShakeCameraNode : UShakeCameraNode
---@field Shakes TArray<UShakeCameraNode>
local UCompositeShakeCameraNode = {}



---@class UControllerGameplayCameraEvaluationComponent : UActorComponent
---@field CameraSystemHost TScriptInterface<IGameplayCameraSystemHost>
local UControllerGameplayCameraEvaluationComponent = {}



---@class UCriticalDamperValueInterpolator : UCameraValueInterpolator
---@field DampingFactor float
local UCriticalDamperValueInterpolator = {}



---@class UDampenPositionCameraNode : UCameraNode
---@field ForwardDampingFactor FFloatCameraParameter
---@field LateralDampingFactor FFloatCameraParameter
---@field VerticalDampingFactor FFloatCameraParameter
---@field DampenSpace ECameraNodeSpace
local UDampenPositionCameraNode = {}



---@class UDampenRotationCameraNode : UCameraNode
---@field YawDampingFactor FFloatCameraParameter
---@field PitchDampingFactor FFloatCameraParameter
---@field RollDampingFactor FFloatCameraParameter
local UDampenRotationCameraNode = {}



---@class UDefaultRootCameraNode : URootCameraNode
---@field BaseLayer UBlendStackCameraNode
---@field MainLayer UBlendStackCameraNode
---@field GlobalLayer UBlendStackCameraNode
---@field VisualLayer UBlendStackCameraNode
local UDefaultRootCameraNode = {}



---@class UDollyFramingCameraNode : UBaseFramingCameraNode
---@field CanMoveLaterally FBooleanCameraParameter
---@field CanMoveVertically FBooleanCameraParameter
local UDollyFramingCameraNode = {}



---@class UDoubleCameraVariable : UCameraVariableAsset
---@field DefaultValue double
local UDoubleCameraVariable = {}



---@class UDoubleIIRValueInterpolator : UCameraValueInterpolator
---@field PrimarySpeed float
---@field IntermediateSpeed float
---@field bUseFixedStep boolean
local UDoubleIIRValueInterpolator = {}



---@class UEnvelopeShakeCameraNode : UShakeCameraNode
---@field EaseInTime FFloatCameraParameter
---@field EaseOutTime FFloatCameraParameter
---@field TotalTime FFloatCameraParameter
---@field Shake UShakeCameraNode
local UEnvelopeShakeCameraNode = {}



---@class UFieldOfViewCameraNode : UCameraNode
---@field FieldOfView FFloatCameraParameter
local UFieldOfViewCameraNode = {}



---@class UFilmbackCameraNode : UCameraNode
---@field SensorWidth FFloatCameraParameter
---@field SensorHeight FFloatCameraParameter
---@field SensorHorizontalOffset FFloatCameraParameter
---@field SensorVerticalOffset FFloatCameraParameter
---@field Overscan FFloatCameraParameter
---@field ConstrainAspectRatio FBooleanCameraParameter
---@field OverrideAspectRatioAxisConstraint FBooleanCameraParameter
---@field AspectRatioAxisConstraint EAspectRatioAxisConstraint
local UFilmbackCameraNode = {}



---@class UFloatCameraVariable : UCameraVariableAsset
---@field DefaultValue float
local UFloatCameraVariable = {}



---@class UGameplayCameraComponent : UGameplayCameraComponentBase
---@field CameraReference FCameraAssetReference
---@field Camera UCameraAsset
local UGameplayCameraComponent = {}



---@class UGameplayCameraComponentBase : USceneComponent
---@field AutoActivateForPlayer EAutoReceiveInput::Type
---@field bSetControlRotationWhenViewTarget boolean
---@field OutputCameraComponent UCineCameraComponent
local UGameplayCameraComponentBase = {}

---@return UCineCameraComponent
function UGameplayCameraComponentBase:GetOutputCameraComponent() end
---@return FBlueprintCameraEvaluationDataRef
function UGameplayCameraComponentBase:GetInitialResult() end
---@param Condition ECameraEvaluationDataCondition
---@return FBlueprintCameraEvaluationDataRef
function UGameplayCameraComponentBase:GetConditionalResult(Condition) end
---@param bImmediately boolean
function UGameplayCameraComponentBase:DeactivateCamera(bImmediately) end
---@param PlayerIndex int32
---@param bSetAsViewTarget boolean
---@param ActivationMode EGameplayCameraComponentActivationMode
function UGameplayCameraComponentBase:ActivateCameraForPlayerIndex(PlayerIndex, bSetAsViewTarget, ActivationMode) end
---@param PlayerController APlayerController
---@param bSetAsViewTarget boolean
---@param ActivationMode EGameplayCameraComponentActivationMode
function UGameplayCameraComponentBase:ActivateCameraForPlayerController(PlayerController, bSetAsViewTarget, ActivationMode) end


---@class UGameplayCameraParameterSetterComponent : UActorComponent
---@field CameraRigReference FCameraRigAssetReference
---@field BlendInTime float
---@field BlendOutTime float
---@field BlendType ECameraVariableSetterBlendType
local UGameplayCameraParameterSetterComponent = {}

---@param bImmediately boolean
function UGameplayCameraParameterSetterComponent:StopParameterSetters(bImmediately) end
function UGameplayCameraParameterSetterComponent:StartParameterSetters() end
---@param OverlappedActor AActor
---@param OtherActor AActor
function UGameplayCameraParameterSetterComponent:OnActorEndOverlap(OverlappedActor, OtherActor) end
---@param OverlappedActor AActor
---@param OtherActor AActor
function UGameplayCameraParameterSetterComponent:OnActorBeginOverlap(OverlappedActor, OtherActor) end


---@class UGameplayCameraRigComponent : UGameplayCameraComponentBase
---@field CameraRigReference FCameraRigAssetReference
---@field GeneratedCameraAsset UCameraAsset
local UGameplayCameraRigComponent = {}



---@class UGameplayCameraSystemComponent : USceneComponent
---@field AutoActivateForPlayer EAutoReceiveInput::Type
---@field bSetPlayerControllerRotation boolean
---@field WeakPlayerController TWeakObjectPtr<APlayerController>
local UGameplayCameraSystemComponent = {}

---@param InstanceId FCameraRigInstanceID
---@param bImmediately boolean
function UGameplayCameraSystemComponent:StopCameraModifierRig(InstanceId, bImmediately) end
---@param CameraRig UCameraRigAsset
---@param OrderKey int32
---@return FCameraRigInstanceID
function UGameplayCameraSystemComponent:StartVisualCameraModifierRig(CameraRig, OrderKey) end
---@param CameraRig UCameraRigAsset
---@param OrderKey int32
---@return FCameraRigInstanceID
function UGameplayCameraSystemComponent:StartGlobalCameraModifierRig(CameraRig, OrderKey) end
---@param PlayerController APlayerController
---@return boolean
function UGameplayCameraSystemComponent:IsCameraSystemActiveForPlayController(PlayerController) end
---@param NextViewTarget AActor
function UGameplayCameraSystemComponent:DeactivateCameraSystem(NextViewTarget) end
---@param PlayerIndex int32
function UGameplayCameraSystemComponent:ActivateCameraSystemForPlayerIndex(PlayerIndex) end
---@param PlayerController APlayerController
function UGameplayCameraSystemComponent:ActivateCameraSystemForPlayerController(PlayerController) end


---@class UGameplayCamerasSettings : UDeveloperSettings
---@field bAutoBuildInPIE boolean
---@field DefaultViewRotationMode EGameplayCamerasViewRotationMode
---@field CombinedCameraRigNumThreshold int32
---@field DefaultIKAimingAngleTolerance double
---@field DefaultIKAimingDistanceTolerance double
---@field DefaultIKAimingMaxIterations uint8
---@field DefaultIKAimingMinDistance double
local UGameplayCamerasSettings = {}



---@class UGameplayControlRotationComponent : UActorComponent
---@field AxisActions TArray<UInputAction>
---@field AxisActionAngularSpeedThreshold float
---@field AxisActionMagnitudeThreshold float
---@field AutoActivateForPlayer EAutoReceiveInput::Type
---@field PlayerController APlayerController
---@field CameraSystemHost TScriptInterface<IGameplayCameraSystemHost>
local UGameplayControlRotationComponent = {}

function UGameplayControlRotationComponent:DeactivateControlRotationManagement() end
---@param PlayerIndex int32
function UGameplayControlRotationComponent:ActivateControlRotationManagementForPlayerIndex(PlayerIndex) end
---@param PlayerController APlayerController
function UGameplayControlRotationComponent:ActivateControlRotationManagementForPlayerController(PlayerController) end


---@class UGameplayTagTransitionCondition : UCameraRigTransitionCondition
---@field PreviousGameplayTagQuery FGameplayTagQuery
---@field NextGameplayTagQuery FGameplayTagQuery
local UGameplayTagTransitionCondition = {}



---@class UIIRValueInterpolator : UCameraValueInterpolator
---@field Speed float
---@field bUseFixedStep boolean
local UIIRValueInterpolator = {}



---@class UInput1DCameraNode : UCameraNode
local UInput1DCameraNode = {}


---@class UInput2DCameraNode : UCameraNode
local UInput2DCameraNode = {}


---@class UInputAxisBinding2DCameraNode : UCameraRigInput2DSlot
---@field AxisActions TArray<UInputAction>
---@field RevertAxisX FBooleanCameraParameter
---@field RevertAxisY FBooleanCameraParameter
---@field Multiplier FVector2dCameraParameter
local UInputAxisBinding2DCameraNode = {}



---@class UInteger32CameraVariable : UCameraVariableAsset
---@field DefaultValue int32
local UInteger32CameraVariable = {}



---@class UIsCameraRigTransitionCondition : UCameraRigTransitionCondition
---@field PreviousCameraRig UCameraRigAsset
---@field NextCameraRig UCameraRigAsset
local UIsCameraRigTransitionCondition = {}



---@class ULensCalibrationCameraNode : UCameraNode
---@field LensFile ULensFile
local ULensCalibrationCameraNode = {}



---@class ULensParametersCameraNode : UCameraNode
---@field FocalLength FFloatCameraParameter
---@field FocusDistance FFloatCameraParameter
---@field Aperture FFloatCameraParameter
---@field EnablePhysicalCamera FBooleanCameraParameter
local ULensParametersCameraNode = {}



---@class ULinearBlendCameraNode : USimpleFixedTimeBlendCameraNode
local ULinearBlendCameraNode = {}


---@class ULocationRotationBlendCameraNode : UBlendCameraNode
---@field LocationBlend USimpleBlendCameraNode
---@field RotationBlend USimpleBlendCameraNode
---@field OtherBlend USimpleBlendCameraNode
local ULocationRotationBlendCameraNode = {}



---@class UMovieSceneCameraFramingZonePropertySystem : UMovieScenePropertySystem
local UMovieSceneCameraFramingZonePropertySystem = {}


---@class UMovieSceneCameraFramingZoneSection : UMovieSceneSection
---@field LeftMarginCurve FMovieSceneDoubleChannel
---@field TopMarginCurve FMovieSceneDoubleChannel
---@field RightMarginCurve FMovieSceneDoubleChannel
---@field BottomMarginCurve FMovieSceneDoubleChannel
local UMovieSceneCameraFramingZoneSection = {}



---@class UMovieSceneCameraFramingZoneTrack : UMovieScenePropertyTrack
local UMovieSceneCameraFramingZoneTrack = {}


---@class UMovieSceneCameraParameterDecoration : UObject
local UMovieSceneCameraParameterDecoration = {}


---@class UMovieSceneCameraParameterInstantiator : UMovieSceneEntityInstantiatorSystem
local UMovieSceneCameraParameterInstantiator = {}


---@class UObjectTreeGraphComment : UObject
local UObjectTreeGraphComment = {}


---@class UOcclusionMaterialCameraNode : UCameraNode
---@field OcclusionTransparencyMaterial UMaterialInterface
---@field OcclusionSphereRadius FFloatCameraParameter
---@field OcclusionChannel ECollisionChannel
---@field OcclusionTargetPosition ECameraNodeOriginPosition
---@field OcclusionTargetOffsetSpace ECameraNodeSpace
---@field OcclusionTargetOffset FVector3dCameraParameter
local UOcclusionMaterialCameraNode = {}



---@class UOffsetCameraNode : UCameraNode
---@field TranslationOffset FVector3dCameraParameter
---@field RotationOffset FRotator3dCameraParameter
---@field OffsetSpace ECameraNodeSpace
local UOffsetCameraNode = {}



---@class UOrbitBlendCameraNode : UBlendCameraNode
---@field DrivingBlend USimpleBlendCameraNode
local UOrbitBlendCameraNode = {}



---@class UOrthographicCameraNode : UCameraNode
---@field EnableOrthographicMode FBooleanCameraParameter
---@field OrthographicWidth FFloatCameraParameter
local UOrthographicCameraNode = {}



---@class UPanningFramingCameraNode : UBaseFramingCameraNode
---@field CanPanLaterally FBooleanCameraParameter
---@field CanPanVertically FBooleanCameraParameter
local UPanningFramingCameraNode = {}



---@class UPerlinNoiseLocationShakeCameraNode : UShakeCameraNode
---@field AmplitudeMultiplier FFloatCameraParameter
---@field FrequencyMultiplier FFloatCameraParameter
---@field Octaves FInteger32CameraParameter
---@field X FPerlinNoiseData
---@field Y FPerlinNoiseData
---@field Z FPerlinNoiseData
local UPerlinNoiseLocationShakeCameraNode = {}



---@class UPerlinNoiseRotationShakeCameraNode : UShakeCameraNode
---@field AmplitudeMultiplier FFloatCameraParameter
---@field FrequencyMultiplier FFloatCameraParameter
---@field Octaves FInteger32CameraParameter
---@field Yaw FPerlinNoiseData
---@field Pitch FPerlinNoiseData
---@field Roll FPerlinNoiseData
local UPerlinNoiseRotationShakeCameraNode = {}



---@class UPopBlendCameraNode : UBlendCameraNode
local UPopBlendCameraNode = {}


---@class UPopValueInterpolator : UCameraValueInterpolator
local UPopValueInterpolator = {}


---@class UPostProcessCameraNode : UCameraNode
---@field PostProcessSettings FPostProcessSettings
local UPostProcessCameraNode = {}



---@class UPriorityQueueCameraDirector : UCameraDirector
local UPriorityQueueCameraDirector = {}


---@class URootCameraNode : UCameraNode
local URootCameraNode = {}


---@class URotator3dCameraVariable : UCameraVariableAsset
---@field DefaultValue FRotator3d
local URotator3dCameraVariable = {}



---@class URotator3fCameraVariable : UCameraVariableAsset
---@field DefaultValue FRotator3f
local URotator3fCameraVariable = {}



---@class USetLocationCameraNode : UCameraNode
---@field Location FVector3dCameraParameter
---@field OffsetSpace ECameraNodeSpace
local USetLocationCameraNode = {}



---@class USetRotationCameraNode : UCameraNode
---@field Rotation FRotator3dCameraParameter
---@field OffsetSpace ECameraNodeSpace
local USetRotationCameraNode = {}



---@class UShakeCameraNode : UCameraNode
local UShakeCameraNode = {}


---@class USimpleBlendCameraNode : UBlendCameraNode
local USimpleBlendCameraNode = {}


---@class USimpleFixedTimeBlendCameraNode : USimpleBlendCameraNode
---@field BlendTime float
local USimpleFixedTimeBlendCameraNode = {}



---@class USingleCameraDirector : UCameraDirector
---@field CameraRig UCameraRigAsset
local USingleCameraDirector = {}



---@class USmoothBlendCameraNode : USimpleFixedTimeBlendCameraNode
---@field BlendType ESmoothCameraBlendType
local USmoothBlendCameraNode = {}



---@class USplineFieldOfViewCameraNode : UCameraNode
---@field SplineInput FFloatCameraParameter
---@field FieldOfViewSpline FCameraSingleCurve
local USplineFieldOfViewCameraNode = {}



---@class USplineOffsetCameraNode : UCameraNode
---@field SplineInput FFloatCameraParameter
---@field TranslationOffsetSpline FCameraVectorCurve
---@field RotationOffsetSpline FCameraRotatorCurve
---@field OffsetSpace ECameraNodeSpace
local USplineOffsetCameraNode = {}



---@class USplineOrbitCameraNode : UCameraNode
---@field LocationOffsetSpline FCameraVectorCurve
---@field TargetOffsetSpline FCameraVectorCurve
---@field RotationOffsetSpline FCameraRotatorCurve
---@field LocationOffsetMultiplier FFloatCameraParameter
---@field TargetOffsetSpace ECameraNodeSpace
---@field InputSlot UInput2DCameraNode
local USplineOrbitCameraNode = {}



---@class UStateTreeCameraDirector : UCameraDirector
---@field StateTreeReference FStateTreeReference
local UStateTreeCameraDirector = {}



---@class UTargetRayCastCameraNode : UCameraNode
---@field TraceChannel ECollisionChannel
---@field AutoFocus FBooleanCameraParameter
local UTargetRayCastCameraNode = {}



---@class UTransform3dCameraVariable : UCameraVariableAsset
---@field DefaultValue FTransform3d
local UTransform3dCameraVariable = {}



---@class UTransform3fCameraVariable : UCameraVariableAsset
---@field DefaultValue FTransform3f
local UTransform3fCameraVariable = {}



---@class UUpdateTrackerCameraNode : UCameraNode
---@field DoubleParameter FDoubleCameraParameter
---@field VectorParameter FVector3dCameraParameter
local UUpdateTrackerCameraNode = {}



---@class UVector2dCameraVariable : UCameraVariableAsset
---@field DefaultValue FVector2D
local UVector2dCameraVariable = {}



---@class UVector2fCameraVariable : UCameraVariableAsset
---@field DefaultValue FVector2f
local UVector2fCameraVariable = {}



---@class UVector3dCameraVariable : UCameraVariableAsset
---@field DefaultValue FVector3d
local UVector3dCameraVariable = {}



---@class UVector3fCameraVariable : UCameraVariableAsset
---@field DefaultValue FVector3f
local UVector3fCameraVariable = {}



---@class UVector4dCameraVariable : UCameraVariableAsset
---@field DefaultValue FVector4d
local UVector4dCameraVariable = {}



---@class UVector4fCameraVariable : UCameraVariableAsset
---@field DefaultValue FVector4f
local UVector4fCameraVariable = {}



---@class UViewTargetTransitionParamsBlendCameraNode : USimpleBlendCameraNode
---@field TransitionParams FViewTargetTransitionParams
local UViewTargetTransitionParamsBlendCameraNode = {}



